﻿using System.Collections.Generic;
using System.Data;
using System.Linq;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 고객
    /// </summary>
    public class Customer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 고객 ID - CustomerID

        /// <summary>
        /// 고객 ID
        /// </summary>
        public string CustomerID { get; set; }

        #endregion
        #region 회사명 - CompanyName

        /// <summary>
        /// 회사명
        /// </summary>
        public string CompanyName { get; set; }

        #endregion
        #region 담당명 - ContactName

        /// <summary>
        /// 담당명
        /// </summary>
        public string ContactName { get; set; }

        #endregion
        #region 담당자 연락처 - ContactTitle

        /// <summary>
        /// 담당자 연락처
        /// </summary>
        public string ContactTitle { get; set; }

        #endregion
        #region 주소 - Address

        /// <summary>
        /// 주소
        /// </summary>
        public string Address { get; set; }

        #endregion
        #region 도시 - City

        /// <summary>
        /// 도시
        /// </summary>
        public string City { get; set; }

        #endregion
        #region 지역 - Region

        /// <summary>
        /// 지역
        /// </summary>
        public string Region { get; set; }

        #endregion
        #region 우편 번호 - PostalCode

        /// <summary>
        /// 우편 번호
        /// </summary>
        public string PostalCode { get; set; }

        #endregion
        #region 국가 - Country

        /// <summary>
        /// 국가
        /// </summary>
        public string Country { get; set; }

        #endregion
        #region 전화 번호 - Phone

        /// <summary>
        /// 전화 번호
        /// </summary>
        public string Phone { get; set; }

        #endregion
        #region 팩스 번호 - Fax

        /// <summary>
        /// 팩스 번호
        /// </summary>
        public string Fax { get; set; }

        #endregion
 
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 고객 리스트 구하기 - GetCustomerList(connection)

        /// <summary>
        /// 고객 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <returns>고객 리스트</returns>
        public static List<Customer> GetCustomerList(IDbConnection connection)
        {
            var resultList = connection.Query<Customer>("SELECT * FROM Customers ORDER BY CustomerID ASC").ToList();

            return resultList;
        }

        #endregion
    }
}