﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 주문
    /// </summary>
    public class Order
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 주문 ID - OrderID

        /// <summary>
        /// 주문 ID
        /// </summary>
        public int OrderID { get; set; }

        #endregion
        #region 고객 ID - CustomerID

        /// <summary>
        /// 고객 ID
        /// </summary>
        public string CustomerID { get; set; }

        #endregion
        #region 직원 ID - EmployeeID

        /// <summary>
        /// 직원 ID
        /// </summary>
        public int? EmployeeID { get; set; }

        #endregion
        #region 주문일 - OrderDate

        /// <summary>
        /// 주문일
        /// </summary>
        public DateTime? OrderDate { get; set; }

        #endregion
        #region 요청일 - RequiredDate

        /// <summary>
        /// 요청일
        /// </summary>
        public DateTime? RequiredDate { get; set; }

        #endregion
        #region 선적일 - ShippedDate

        /// <summary>
        /// 선적일
        /// </summary>
        public DateTime? ShippedDate { get; set; }

        #endregion
        #region 선적 수단 - ShipVia

        /// <summary>
        /// 선적 수단
        /// </summary>
        public int? ShipVia { get; set; }

        #endregion
        #region 운임 - Freight

        /// <summary>
        /// 운임
        /// </summary>
        public decimal? Freight { get; set; }

        #endregion
        #region 선적명 - ShipName

        /// <summary>
        /// 선적명
        /// </summary>
        public string ShipName { get; set; }

        #endregion
        #region 선적 주소 - ShipAddress

        /// <summary>
        /// 선적 주소
        /// </summary>
        public string ShipAddress { get; set; }

        #endregion
        #region 선적 도시 - ShipCity

        /// <summary>
        /// 선적 도시
        /// </summary>
        public string ShipCity { get; set; }

        #endregion
        #region 선적 지역 - ShipRegion

        /// <summary>
        /// 선적 지역
        /// </summary>
        public string ShipRegion { get; set; }

        #endregion
        #region 선적 우편 번호 - ShipPostalCode

        /// <summary>
        /// 선적 우편 번호
        /// </summary>
        public string ShipPostalCode { get; set; }

        #endregion
        #region 선적 국가 - ShipCountry

        /// <summary>
        /// 선적 국가
        /// </summary>
        public string ShipCountry { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 주문 리스트 구하기 - GetOrderList(connection)

        /// <summary>
        /// 주문 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <returns>주문 리스트</returns>
        public static List<Order> GetOrderList(IDbConnection connection)
        {
            var resultList = connection.Query<Order>("SELECT * FROM Orders ORDER BY OrderID ASC").ToList();

            return resultList;
        }

        #endregion
        #region 주문 리스트 구하기 - GetOrderList(connection, customer)

        /// <summary>
        /// 주문 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <param name="customer">고객</param>
        /// <returns>주문 리스트</returns>
        public static List<Order> GetOrderList(IDbConnection connection, Customer customer)
        {
            var resultList = connection.Query<Order>
            (
                "SELECT * FROM Orders WHERE CustomerID = @CustomerID ORDER BY OrderID ASC",
                customer
            ).ToList();

            return resultList;
        }

        #endregion
    }
}